// NETWORKING SYNC SCRIPTS
//
//
sendHello = '
	write_ubyte(argument0, carriers.WELCOME);
';
serializeChars = '
	var i, p;
	write_ubyte(argument0, carriers.CHAR_SYNC);
	write_ubyte(argument0, instance_number(Character));
	with(Character) {
		write_ubyte(argument0, ds_list_find_index(global.players, player));
		if(carrier == noone) {
			write_ubyte(argument0, 255);
		} else {
			write_ubyte(argument0, ds_list_find_index(global.players, carrier.player));
		}
		if(carry == noone) {
			write_ubyte(argument0, 255);
		} else {
			write_ubyte(argument0, ds_list_find_index(global.players, carry.player));
		}
		write_ubyte(argument0, carryRunning);
	}
';
deserializeChars = '
	var player;
	repeat(read_ubyte(argument0)) {
		player = ds_list_find_value(global.players, read_ubyte(argument0));
		if(player.object == -1) {
			repeat(3) read_ubyte(argument0);
		} else {
			with(player.object) {
				carrier = read_ubyte(argument0);
				if(carrier == 255) {
					carrier = noone;
				} else {
					carrier = ds_list_find_value(global.players, carrier).object;
				}
				carry = read_ubyte(argument0);
				if(carry == 255) {
					carry = noone;
				} else {
					carry = ds_list_find_value(global.players, carry).object;
				}
				carryRunning = read_ubyte(argument0);
			}
		}
	}
'
serializePlayers = '
	var i, j, p, p2;
	write_ubyte(argument0, carriers.PLAYER_SYNC);
	for(i = 0; i < ds_list_size(global.players); i+=1) {
		p = ds_list_find_value(global.players, i);
		write_ubyte(argument0, ds_list_find_index(global.players, p));
		write_ubyte(argument0, p.carryEnable);
		write_ubyte(argument0, p.carryForbidden);
		write_ubyte(argument0, ds_list_size(p.forbiddenCarriers));
		for(j = 0; j < ds_list_size(p.forbiddenCarriers); j+=1) {
			p2 = ds_list_find_value(p.forbiddenCarriers, j);
			write_ubyte(argument0, ds_list_find_index(global.players, p2));
		}
	}
';
deserializePlayers = '
	var player, p2;
	repeat(ds_list_size(global.players)) {
		player = ds_list_find_value(global.players, read_ubyte(argument0));
		player.carryEnable = read_ubyte(argument0);
		player.carryForbidden = read_ubyte(argument0);
		ds_list_clear(player.forbiddenCarriers);
		repeat(read_ubyte(argument0)) {
			p2 = ds_list_find_value(p.forbiddenCarriers, read_ubyte(argument0));
			ds_list_add(forbiddenCarriers, p2);
		}
	}
';

// send buffer to players who have been welcomed
// argument0: the buffer to send
sendToWelcomedPlayers = '
	for(i = 0; i < ds_list_size(global.players); i+=1) {
		p = ds_list_find_value(global.players, i);
		if(p.carryWelcomed) {
			PluginPacketSendTo(packetID, argument0, p);
		}
	}
';